-----------------------------------------------------------------------------
--  InterruptBar2 by Wardz. (Felesake) | Based on InterruptBar by Kollektiv.
-- 	Version 1.1.61
-----------------------------------------------------------------------------
-- Locals
local addonName, addonTable = ...
local IB = CreateFrame('Frame')
local bar
local IsInArena
local IB2Options
local db = {}
local btns = {}
local L = addonTable.L

local chargedSpells = {
	[1022] = 300,	-- Hand of Protection
	[1044] = 25,	-- Hand of Freedom
	[6940] = 120, 	-- Hand of Sacrifice
	[105174] = 15,  -- Hand of Gul'dan
	[48982] = 30,  	-- Rune Tap
	[115399] = 60,  -- Chi Brew
	[115008] = 20,  -- Chi Torpedo
	[100] = 20,     -- Charge
	[2565] = 12, 	-- Shield Block
	[156321] = 15,  -- Shield Charge
	[109132] = 20,	-- Roll
	[19263] = 180,	-- Deterrence
	[113858] = 120,	-- Dark Soul: Instability
	[113861] = 120,	-- Dark Soul: Knowledge
	[113860] = 120,	-- Dark Soul: Misery
	[61336] = 180,	-- Survival Instincts
	[157981] = 25,	-- Blast Wave
	[157980] = 25,	-- Supernova
	[157997] = 25,	-- Ice Nova
}

--Positions
local offsetX = 0
local offsetY = 0
local count = 0

-- Cache frequently used globals in locals
local OnEvent, SetAlpha, UIFrameFadeOut, IsVisible, GetAlpha, SendChatMessage, floor, tonumber, ceil, Hide, Show, SetText, GetFont, SetAlpha, STANDARD_TEXT_FONT, SetTextColor, SetScript, SetCooldown, UnitInParty, SetFont, OnUpdate, strformat, pairs, GetTime, bit_band, _G, SPELL_CAST_SUCCESS, COMBAT_LOG_EVENT_UNFILTERED, COMBATLOG_OBJECT_REACTION_HOSTILE, _ =
	  OnEvent, SetAlpha, UIFrameFadeOut, IsVisible, GetAlpha, SendChatMessage, floor, tonumber, ceil, Hide, Show, SetText, GetFont, SetAlpha, STANDARD_TEXT_FONT, SetTextColor, SetScript, SetCooldown, UnitInParty, SetFont, OnUpdate, string.format, pairs, GetTime, bit.band, _G, SPELL_CAST_SUCCESS, COMBAT_LOG_EVENT_UNFILTERED, COMBATLOG_OBJECT_REACTION_HOSTILE, _

--[[ Note:
	99% of code in this addon is from when I just started learning lua.
	Some functions will be very inefficient (mainly event handling and recreating frames/tables).
	I'll be recoding the whole addon when I get the time for it.
]]





----------------------------------
-- Saved Variables
----------------------------------

function IB:InsertVariables(Src, Dst)
	for key, value in pairs(Src) do
		if ( Dst[key] == nil ) then
			Dst[key] = value
		elseif ( type(value) == 'table' ) then
			Dst[key] = IB:InsertVariables(value, Dst[key])
		end
	end

	return Dst
end

function IB:RemoveVariables(Src, Dst)
	for key, value in pairs(Src) do
		if ( Dst[key] == nil ) then
			Src[key] = nil
		elseif ( type(value) == 'table' ) then
			if not Dst["abilities"] then
				Dst[key] = IB:RemoveVariables(value, Dst[key])
			end
		end
	end

	return Dst
end

function IB:UpdateVariables(defaultSettings)
	if not ( db ) or ( InterruptBar2DB.scale ) then -- Check if old key value exists in table
		wipe(db)
		wipe(InterruptBar2DB)
		IB:SavedVariables()
	end

	if ( db.version and db.version == '1.1.63' ) then return end -- No need for updating
	IB:InsertVariables(defaultSettings, db)
	IB:RemoveVariables(db, defaultSettings)
end

function IB:SavedVariables()
	InterruptBar2DB = InterruptBar2DB or {}
	local characterInfo = UnitName('player') .. ' - ' .. GetRealmName()
	local defaultSettings = {
		version 		= '1.1.63',
		smartArena 		= true,
		overlayDuration = 2,
		growUp			= 1.1,
		growLeft		= 1.1,
		overlayFinish	= false,
		overlayStart 	= true,
		spiralHide 		= false,
		barScale 		= 0.9,
		barHideMode 	= false,
		barSmartMode 	= false,
		barLock 		= false,
		barCols			= 7,
		barTextures 	= true,
		--barOffsetY 		= 33,
		--barOffsetX 		= 33,
		barTransparent 				= false,
		barTransparencyFiveLeft 	= 1,
		barTransparencySeconds		= 1,
		barTransparencyMinute 		= 1,
		barTransparency 			= 1,
		timerHide 		= false,
		timerScale 		= 15,
		timerDecimal 	= false,
		timerOffsetX 	= 0,
		timerOffsetY 	= 0,
		timerColor = {
			r = 1,
			g = 1,
			b = 0,
			a = 1,
		},
		zoneBattle 			= false,
		zoneArena 			= false,
		announceFinish 		= false,
		announceFiveLeft 	= false,
		announceOnUse 		= false,
		announceChannel		= 'PARTY',
		timerScaleFiveLeft 	= 17,
		timerColorFiveLeft 	= {
			r = 1,
			g = 0,
			b = 0,
			a = 1,
		},
		timerScaleMinute = 15,
		timerColorMinute = {
			r = 1,
			g = 1,
			b = 1,
			a = 1,
		},
		Position = {
			point = "CENTER",
			relativePoint = "CENTER",
			xOfs = 2,
			yOfs = -100,
		},
		abilities = {
			['MAGE'] = {
				[2139] 		= 24, 	-- Counterspell
			},
			['WARLOCK'] = {
				[19647] 	= 24,	-- Spell lock
			},
			['WARRIOR'] = {
				[6552] 		= 15,
			},
			['DRUID'] = {
				[106839] 	= 15, 	-- Skull Bash
				[78675] 	= 60, 	-- Solar Beam
			},
			['MONK'] = {
				[116705]	= 15,	-- Spear Hand Strike
			},
			['SHAMAN'] = {
				[57994] 	= 12,	-- Wind Shear
			},
			['PRIEST'] = {
				[15487] 	= 45,	-- Silence
			},
			['ROGUE'] = {
				[1766] 		= 15,	-- Kick
			},
			['HUNTER'] = {
				[147362] 	= 24,	-- Counter Shot
			},
			['PALADIN'] = {
				[96231] 	= 15,	-- Rebuke
			},
			['DEATHKNIGHT'] = {
				[47528] 	= 15, 	-- Mind Freeze
				[47476]		= 60,	-- Strangulate
				[91802] 	= 30,	-- Shambling Rush (Pet)
			},
			-- [Arcane Torrent]
		},
	}

	InterruptBar2DB[characterInfo] = InterruptBar2DB[characterInfo] or defaultSettings
	db = InterruptBar2DB[characterInfo]

	IB:UpdateVariables(defaultSettings)
	
	offsetX = 15+((db.barCols/2)*-36*((db.growLeft+1)/2))+((db.barCols/2)*-36*((db.growLeft-1)/2))
end

----------------------------------
-- Core functions
----------------------------------

function IB:FormatColor(ColorTable)
	local r,g,b,a = ColorTable['r'], ColorTable['g'], ColorTable['b'], ColorTable['a']
	return r,g,b,a
end

function IB:FormatValue(Value)
	local number = tonumber(Value)
	local format = floor(number * 100 + 0.5) / 100
	return format
end

function IB:SetText(Frame, Colors, Size, FormatType, Minutes, Seconds)
	local fontName, fontHeight = Frame:GetFont()
	local fontR, fontG, fontB, fontA = Frame:GetTextColor()
	if not ( fontName ) or not ( fontHeight ) or ( IB:FormatValue(fontHeight) ~= IB:FormatValue(Size) ) then
		-- Only update font if something actually changed
		Frame:SetFont(STANDARD_TEXT_FONT, IB:FormatValue(Size), 'OUTLINE')
	elseif ( not fontR or fontG or fontB or fontA ) or ( fontR and fontG and fontB and fontA ) ~= ( IB:FormatColor(Colors) ) then
		-- prob an easier way to do this but w/e
		Frame:SetTextColor( IB:FormatColor(Colors) )
	end

	if ( fontName ) then
		if ( Minutes and Seconds ) then
			-- Text for timers greater than 60sec
			Frame:SetText(strformat(FormatType, tonumber(Minutes), tonumber(Seconds) ))
		else
			-- Text for timers less than 60sec
			Frame:SetText(strformat(FormatType, tonumber(Seconds) ))
		end
	end
end

local lastMessage, lastMessageTime
function IB:Announce(spellName, textMessage)
	if db.announceChannel == 'PARTY' then
		if not ( UnitInParty('player') ) then
			return
		end
	end
	-- Throttle messages
	if ( lastMessageTime ) and ( lastMessage ) then
		if ( lastMessage == spellName ) and ( lastMessageTime - GetTime() > 5 ) then
			return
		end
	end

	SendChatMessage(spellName..textMessage, db.announceChannel)
	lastMessage = spellName
	lastMessageTime = GetTime()
end

function IB:UpdateFunctions(btn, cooldown)
	if ( cooldown <= 5 ) then
		btn:SetAlpha(db.barTransparencyFiveLeft)
		--if ( db.announceFiveLeft ) then
			--IB:Announce(btn.name, ' READY IN 5!')
		--end
	elseif ( cooldown >= 60 ) then
		btn:SetAlpha(db.barTransparencyMinute)
	else
		btn:SetAlpha(db.barTransparencySeconds)
	end
end

function IB:UpdateTimerText(text, CooldownTime, btn)
	local cooldown
	local numbers
	if not ( db.timerDecimal ) then
		cooldown = floor(CooldownTime * 10 ^ 1  +.5)  / 10 / 1
		--cooldown = IB:FormatValue(CooldownTime) calling func too slow?
	else
		cooldown = floor(CooldownTime + 0.5)
	end

	local minutes = floor(cooldown / 60)
	if ( minutes > 0 ) then
		-- Show minutes and seconds
		local seconds = cooldown - minutes * 60
		if ( minutes < 1 ) then
			numbers = '%s'
		else
			numbers = '%s:%.0f'
		end

		IB:SetText(text,db.timerColorMinute,db.timerScaleMinute,numbers,minutes,seconds)
	else
		if ( cooldown > 5 ) then
			-- CD is higher than 5s and below 60s
			if ( db.timerDecimal ) then
				numbers = '%d'
			else
				numbers = '%.0f'
			end
			IB:SetText(text,db.timerColor,db.timerScale,numbers,nil,cooldown)
		else
			-- CD have less than 5s left
			numbers = '%.0f'
			IB:SetText(text,db.timerColorFiveLeft,db.timerScaleFiveLeft,numbers,nil,cooldown)

			if ( cooldown == 0 ) then
				text:SetText('')
			else
				if ( not db.timerDecimal ) then
					if not ( cooldown >= 1 ) then
						numbers = '.' .. floor(cooldown * 10)
					else
						numbers = '%.1f'
					end
				else
					numbers = '%d'
				end

				text:SetText(strformat(numbers, cooldown))
			end
		end
	end
end

function IB:Activate(...)
	local btn, start, miss, reCharge = ...

	-- Restart
	if ( btn.active ) then
		IB:Deactivate(...)
		IB:Activate(...)
	end

	if db.barSmartMode and db.barHideMode then
		self:UpdatePosition(btn)
	end

	-- Show if hidden
	if ( db.barHideMode ) and not db.barSmartMode then
		if not ( btn:IsVisible() ) then
			btn:Show()
		end
	end

	-- Show overlay if SPELL_MISSED
	if ( miss ) then
		btn.texture:SetVertexColor(0.7, 1, 1, 1)
	else
		btn.texture:SetVertexColor(1, 1, 1, 1)
	end

	if not ( db.timerHide ) then
		if not ( btn.text:IsVisible() ) then
			btn.text:Show()
		end
	end

	local cooldown = btn.duration - ( GetTime() - start )
	btn.active = true

	if not ( db.spiralHide ) then
		if not ( btn.cd:IsVisible() ) then
			btn.cd:Show()
		end
		btn.cd:SetCooldown(start, cooldown)
	end

	if ( db.overlayDuration ~= 0 ) and ( db.overlayStart ) then
		UIFrameFadeOut(btn.overlay, db.overlayDuration, 1, 0)
	end

	if ( db.announceOnUse ) then
		IB:Announce(btn.name, ' USED!')
	end

	if chargedSpells[btn.spellID] then
		if not reCharge then
			btn.chargeValue = btn.chargeValue - 1
		end
		if btn.chargeValue > 2 then
			btn.chargeValue = 2
		elseif btn.chargeValue < 0 then
			btn.chargeValue = 0
		end
		btn.chargeText:SetText(tostring(btn.chargeValue))
	end

	-- OnUpdate
	btn:SetScript('OnUpdate', function(self, elapsed)
		cooldown = cooldown - elapsed
		if ( cooldown <= 0 ) then
			IB:Deactivate(btn)
		else
			if not ( db.timerHide ) then
				IB:UpdateTimerText(btn.text, cooldown, btn)
			end

			IB:UpdateFunctions(btn, cooldown)
		end
	end)
end

function IB:Deactivate(btn, start, miss)
	if not ( db.spiralHide ) then
		-- For animation effect
		btn.cd:SetCooldown(0, 0)
	end

	if ( db.barHideMode ) and not db.barSmartMode then
		if ( btn:IsVisible() ) then
			btn:Hide()
		end
	end

	if ( not db.timerHide ) then
		if ( btn.text:IsVisible() ) then
			btn.text:Hide()
		end
	end

	if ( db.announceFinish ) then
		IB:Announce(btn.name,' READY!')
	end

	-- SPELL_MISSED 
	btn.texture:SetVertexColor(1, 1, 1, 1)

	-- Set transparent end
	if not ( db.barHideMode ) then
		local alphaValue = IB:FormatValue( btn:GetAlpha() )
		if ( alphaValue ) ~= ( IB:FormatValue(db.barTransparency) ) then
			btn:SetAlpha(db.barTransparency)
		else
			if ( alphaValue ) ~= 1 then
				btn:SetAlpha(1)
			end
		end
	end

	-- Activation Border
	if ( db.overlayDuration ~= 0 ) and ( db.overlayFinish ) then
		UIFrameFadeOut(btn.overlay, db.overlayDuration, 1, 0)
	end

	btn:SetScript('OnUpdate', nil)
	btn.active = false

	if db.barHideMode and db.barSmartMode then
		IB:Reposition()
	end

	if chargedSpells[btn.spellID] then
		btn.chargeValue = btn.chargeValue + 1
		if btn.chargeValue > 2 then
			btn.chargeValue = 2
		elseif btn.chargeValue < 0 then
			btn.chargeValue = 0
		end
		btn.chargeText:SetText(tostring(btn.chargeValue))
		if btn.chargeValue == 1 then
			self:Activate(btn, GetTime(), false, true)
		end
	end
end

-- Create frame for every spell info received
function IB:CreateIcon(spellID, spellCD)
	local btn = CreateFrame('CheckButton', 'IB2Button_'..spellID, bar, 'ActionButtonTemplate')
	local _,_,spellIcon = GetSpellInfo(spellID)
	btn:Disable()
	btn:EnableMouse(false)
	btn:SetSize(36, 36)

	-- Cooldown Spiral
	btn.cd = CreateFrame('Cooldown', 'IB2ButtonCD'..spellID, btn, 'CooldownFrameTemplate')
		btn.cd:SetAllPoints(btn)
		btn.cd.noCooldownCount = true
		btn.cd:SetDrawSwipe(not db.spiralHide)
		btn.cd:SetHideCountdownNumbers(true)
		btn.cd:SetDrawEdge(false)
		btn.cd:SetSwipeColor( 0,0,0, 0.60 )
		btn.cd:Hide()

	if chargedSpells[spellID] then
		btn.chargeText = btn:CreateFontString(nil, 'OVERLAY')
		btn.chargeText:SetPoint('CENTER', btn, 10, -9)
		btn.chargeText:SetFont(STANDARD_TEXT_FONT, 12, 'OUTLINE')
		btn.chargeText:SetTextColor(1,1,1,1)
		btn.chargeText:SetText('2')
		btn.chargeValue = 2
	end

	-- Text Timer
	if not db.timerHide then
		local frameType
		if db.spiralHide then frameType = btn else frameType = btn.cd end -- Attach to btn if btn.cd is disabled
		btn.text = frameType:CreateFontString(nil, "OVERLAY")
		btn.text:SetPoint("CENTER", frameType, db.timerOffsetX, db.timerOffsetY)
		btn.text:Hide()
	end

	btn:SetFrameStrata('LOW')
	btn.duration = spellCD
	btn.name = GetSpellInfo(spellID)
	btn.spellID = spellID

	-- Icon
	btn.texture = btn:CreateTexture(nil, "BACKGROUND")
	btn.texture:SetAllPoints(btn)
	btn.texture:SetTexture(spellIcon)
	btn.texture:SetTexCoord(0.07, 0.9, 0.07, 0.90)
	if not db.barTextures then
		btn:SetNormalTexture(nil) -- Hide actionbar button borders
	end

	-- Activation Border
	if ( db.overlayDuration ~= 0 ) and ( db.overlayFinish or db.overlayStart ) then
		btn.overlay = btn:CreateTexture(nil, 'OVERLAY')
			btn.overlay:SetAllPoints(btn)
			btn.overlay:SetTexture('Interface/SpellActivationOverlay/IconAlert')
			btn.overlay:SetTexCoord(0.00781250, 0.50781250, 0.27734375, 0.52734375)
			btn.overlay:SetPoint('TOPLEFT', btn, 'TOPLEFT', -36 * 0.4, 36 * 0.4)
			btn.overlay:SetPoint('BOTTOMRIGHT', btn, 'BOTTOMRIGHT', 36 * 0.4, -36 * 0.4)
			btn.overlay:SetAlpha(0)
	end

	-- Masque
	if LibStub("Masque", true) then
		--[[if not btn:GetNormalTexture() then
			button:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2")
			db.barTextures = true
		end]]

		local GetName = btn:GetName()
		LibStub("Masque"):Group("InterruptBar2", btn.name):AddButton(btn, {
			FloatingBG = _G[GetName.."FloatingBG"],
			Icon = btn.texture,
			Cooldown = btn.cd,
			Flash = _G[GetName.."Flash"],
			Pushed = btn:GetPushedTexture(),
			Normal = btn:GetNormalTexture(),
			Disabled = btn:GetDisabledTexture(),
			Checked = btn:GetCheckedTexture(),
			Border = _G[GetName.."Border"],
			AutoCastable = _G[GetName.."AutoCastable"],
			Highlight = btn:GetHighlightTexture(),
			Hotkey = _G[GetName.."Hotkey"],
			Count = _G[GetName.."Count"],
			Name = _G[GetName.."Name"],
			Duration = _G[GetName.."Duration"],
			AutoCast = _G[GetName.."Shine"],
		})
	end

	return btn
end

-- Create icon only if arena opponent class matches ability class
local unitCache = {}
function IB:DetectArena(event, type, unit)
	if not ( IsInArena ) then
		return
	end
	if event == "ARENA_OPPONENT_UPDATE" then
		if type ~= "seen" then return end
	end
	local numOpps = GetNumArenaOpponentSpecs()

	for i = 1, MAX_ARENA_ENEMIES do
		if not unitCache[i] then
		if ( i <= numOpps ) then
			local specID = GetArenaOpponentSpec(i)
			if ( specID > 0 ) then
				local _,_,_,_,_,_, enemyClass = GetSpecializationInfoByID(specID)
				-- TODO: add spells by spec instead of class
				-- note: returns localized spec name, use spec id instead
				if ( enemyClass ) then
					for class, table in pairs(db.abilities) do
						if enemyClass == class then
							for ability,cooldown in pairs(table) do
								if not btns[ability] then
									local btn = IB:CreateIcon(ability, cooldown)
									btns[ability] = btn
									unitCache[i] = true

									btn:SetPoint('CENTER', bar, 'CENTER', offsetX, offsetY)

									offsetX = offsetX + 36 * db.growLeft
									count = count + 1

									if count >= db.barCols and db.barCols > 0 then
										offsetY = offsetY  - 36 * db.growUp
										offsetX = 15+((db.barCols/2)*-36*((db.growLeft+1)/2))+((db.barCols/2)*-36*((db.growLeft-1)/2))
										count=0
									end	
								end
							end
						end
					end
				end
			end
		end
	end
	end
	IB:UpdateFrame()
end

function IB:AddIcons()
	if not ( IsInArena ) then
		for _, table in pairs(db.abilities) do
			for ability, cooldown in pairs(table) do
				local btn = IB:CreateIcon(ability, cooldown)

				btns[ability] = btn

				btn:SetPoint('CENTER', bar, 'CENTER', offsetX, offsetY)
				
				offsetX = offsetX + 36 * db.growLeft
				count = count + 1

				if count >= db.barCols and db.barCols > 0 then
					offsetY = offsetY  - 36 * db.growUp
					offsetX = 15+((db.barCols/2)*-36*((db.growLeft+1)/2))+((db.barCols/2)*-36*((db.growLeft-1)/2))
					count=0
				end
			end
		end
		offsetX = 15+((db.barCols/2)*-36*((db.growLeft+1)/2))+((db.barCols/2)*-36*((db.growLeft-1)/2))
		count   = 0
		offsetY = 0
	end
end


-- from Juked
function IB:UpdatePosition(btn)
	--if not btn:IsVisible() then
		btn:SetPoint('CENTER', bar, offsetX, offsetY)
		btn:Show()
		
		offsetX = offsetX + 36 * db.growLeft
		count = count + 1

		if count >= db.barCols and db.barCols > 0 then
			offsetY = offsetY - 36 * db.growUp
			offsetX = 15+((db.barCols/2)*-36*((db.growLeft+1)/2))+((db.barCols/2)*-36*((db.growLeft-1)/2))
			count = 0
		end
	--end
end

function IB:Reposition()
	if db.barSmartMode then
		if db.barHideMode then
			offsetX = 15+((db.barCols/2)*-36*((db.growLeft+1)/2))+((db.barCols/2)*-36*((db.growLeft-1)/2))
			count = 0
			offsetY = 0
		end
		for _,btn in pairs(btns) do
			--btn:Hide()
			if btn.active then
				IB:UpdatePosition(btn)
			else
				if db.barHideMode then
					btn:Hide()
				end
			end
		end
	end
end

-- Create main bar frame
function IB:CreateBar()
	bar = CreateFrame('Frame', nil, UIParent)
	bar:SetClampedToScreen(true)
	bar:EnableMouse(true)
	bar:SetMovable(true)
	bar:SetScale(db.barScale)

	-- Start moving
	bar:SetScript('OnMouseDown', function(self) if not db.barLock then self:StartMoving() end end)

	-- Stop moving
	bar:SetScript('OnMouseUp', function(self,button)
		if button == 'RightButton' then
			if not db.barLock then
				db.barLock = true
				IB:Restart()
			end
		end
		self:StopMovingOrSizing()
		--local point _, relativePoint, xOfs, yOfs = self:GetPoint
		db.Position.point, _, db.Position.relativePoint,db.Position.xOfs,db.Position.yOfs = self:GetPoint()
	end)

	bar:SetWidth(200)
	bar:SetHeight(25)

	-- Text tooltip
	bar.Text = bar:CreateFontString(nil, 'ARTWORK')
		bar.Text:SetPoint('TOP', bar, 'TOP', 0, -6)
		bar.Text:SetFont(STANDARD_TEXT_FONT, 10 , 'OUTLINE')
		bar.Text:SetText(L['Left Click - Move | Right Click - Lock'])
		bar:SetBackdrop({bgFile = 'Interface\\ChatFrame\\ChatFrameBackground', edgeFile='Interface\\Tooltips\\UI-Tooltip-Border',tileSize=36+2,edgeSize=.3*36,})
		bar:Show()

	if ( db.Position.point ) then
		bar:SetPoint(db.Position.point,UIParent,db.Position.relativePoint,db.Position.xOfs,db.Position.yOfs)
	end

	IB:AddIcons()
	IB:UpdateFrame()
end

----------------------------------
-- Combat Log 
----------------------------------
local spellResets = {
	[11958] = {	-- Cold Snap
		12043, 	-- Presence of Mind
		31661, 	-- Dragon's Breath
		120, 	-- Cone of Cold
		122, 	-- Frost Nova
		45438, 	-- Ice Block
		157913, -- Evanesce
	},
	[14185] = { -- Preparation
		2983,	-- Sprint
		1856, 	-- Vanish
		5277,	-- Evasion
	},
	[108285] = { -- Call of the Elements
		157153,	 -- Cloudburst Totem
		108269,	 -- Capacitor Totem
		8143,	 -- Tremor Totem
		8177,	 -- Grounding Totem
		51485,	 -- Earthgrab Totem
		108273,	 -- Windwalk Totem
		5394,	 -- Healing Stream Totem
		2484,	 -- Earthbind Totem
		108270,	 -- Stone Bulwark Totem
	},
}

local spellRedirects = {
	[132409] = 19647,	-- Spell Lock -> Spell Lock (Grimoire of Sacrifice)
	[115781] = 19647,	-- Optical Blast -> Spell Lock
	[171139] = 19647,	-- Shadow Lock -> Spell Lock
	[119910] = 19647,	-- Spell Lock -> Spell Lock (Grimoire of Service?)
	[ 91807] = 91802,	-- Shambling Rush -> Shambling Rush (Dunno which ID is right)
	[109132] = 115008,	-- Roll -> Chi Torpedo
	[126135] = 724,		-- Lightwell -> Lightwell (Dunno which ID is right)
	[1499] = 60192,		-- Freezing Trap -> Freezing Trap Launcher
	[129250] = 14914,	-- Power Word: Solace -> Holy Fire
}

function IB:CLEU(...)
	local _, eventType, _, _, _, srcFlags, _, _, _, _, _, spellID = ...
	if not ( bit_band(srcFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) ~= 0 )  then return end
	if not ( btns[spellID] or spellResets[spellID] or spellRedirects[spellID] ) then return end

	local start = GetTime()
	if ( eventType == 'SPELL_CAST_SUCCESS' ) then
		-- Reset abilities
		if ( spellResets[spellID] ) then
			for _,v in pairs(spellResets[spellID]) do
				local btn = btns[v]
				if ( btn and btn.active) then
					IB:Deactivate(btn)
				end
			end
		end

		if spellRedirects[spellID] then
		for k,v in pairs(spellRedirects) do
			if spellID == k then
				spellID = v
			end
		end
		end

		local btn = btns[spellID]
		if ( btn ) then
			IB:Activate(btn, start)
		end

		return
	elseif ( eventType == 'SPELL_MISSED' ) then
		local btn  = btns[spellID]
		local miss = true
		if ( btn ) then
			IB:Activate(btn, start, miss)
		end
		return
	end
end

----------------------------------
-- Restart/Update
----------------------------------

-- Update settings that doesn't require recreating a frame
function IB:UpdateFrame()
	bar:Show()
	for _,btn in pairs(btns) do
		IB:Deactivate(btn)
		if ( db.barHideMode ) then
			btn:Hide()
		else
			btn:Show()
		end

		if not ( db.barHideMode ) then
			btn:SetAlpha(db.barTransparency)
		else
			btn:SetAlpha(1)
		end
	end

	--
	bar:SetScale(db.barScale)

	--
	if ( db.barLock ) then
		bar:EnableMouse(false)
		bar.Text:Hide()
		bar:SetBackdropColor(0,0,0,0)
		bar:SetBackdropBorderColor(0,0,0,0)
	else
		bar:EnableMouse(true)
		bar.Text:Show()
		bar:SetBackdropColor(0,0,0,.7)
		bar:SetBackdropBorderColor(1,1,1,1)
	end
end

function IB:Restart()
	for _,btn in pairs(btns) do
		if not ( btn ) then return end
		if ( btn.active ) then
			IB:Deactivate(btn)
		end
		btn:Hide()
		btn = nil
	end
		offsetX = 15+((db.barCols/2)*-36*((db.growLeft+1)/2))+((db.barCols/2)*-36*((db.growLeft-1)/2))
		count   = 0
		offsetY = 0
	wipe(btns)
	wipe(unitCache)
	IB:AddIcons() --print offsetx ?
	IB:UpdateFrame()
end

----------------------------------
-- Options
----------------------------------

-- Create tooltip
local function AddTooltip(Parent, tooltipText)
	Parent:SetScript('OnEnter', function(self)
		if ( self.OnEnter ) then
			self:OnEnter()
		else
			GameTooltip:SetOwner(self, 'ANCHOR_RIGHT')
			GameTooltip:SetText(tooltipText, nil, nil, nil, nil, true)
			GameTooltip:Show()
		end
	end)

	Parent:SetScript('OnLeave', function(self)
		if self.OnLeave then
			self:OnLeave()
		else
			GameTooltip:Hide()
		end
	end)
end

-- Create button
local function CreateButton(Label, Parent, Point, ofsX, ofsY, tooltipText)
	local button = CreateFrame('Button', nil, Parent, 'UIPanelButtonTemplate')
	button:SetWidth(45)
	button:SetHeight(30)
	button.text = button:CreateFontString(nil, 'ARTWORK', 'GameFontNormal')
	button.text:SetPoint('CENTER', button)
	button.text:SetText(Label)
	button:SetPoint(Point, Parent, ofsX, ofsY)

	if ( tooltipText ) then
		AddTooltip(button, tooltipText)
	end
	return button
end

local function Log(message)
	DEFAULT_CHAT_FRAME:AddMessage('|cff32cd32InterruptBar2:|r '.. message)
end

function IB:LoadOptions()
	-- Load libraries
	local dropdownLib = LibStub("IB2Config-Dropdown", true)
	local colorLib	  = LibStub("IB2Config-ColorPicker", true)
	local playerName  = UnitName('player') .. ' - ' .. GetRealmName()
	if not ( dropdownLib ) or not ( colorLib ) then
		Log(L['Libraries not loaded. Disabled options.'])
		return
	end

	-- Create slider
	local function CreateSlider(Label, Parent, LowValue, HighValue, StepValue, dbValue, Point, ofsX, ofsY, tooltipText)
		local name = 'IB2:' .. Label
		local slider = CreateFrame('Slider', name, Parent, 'OptionsSliderTemplate')
		slider:SetWidth(145)
		slider:SetMinMaxValues(LowValue, HighValue)
		slider:SetObeyStepOnDrag(true)
		slider:SetValueStep(StepValue)
		slider:SetValue(dbValue)
		slider:SetPoint(Point, Parent, ofsX, ofsY)
		_G[name..'Text']:SetText(Label)
		_G[name..'Text']:SetTextColor(0.9,0.8,0,1)
		_G[name..'Low']:SetText(LowValue)
		_G[name..'High']:SetText(HighValue)

		if ( tooltipText ) then
			AddTooltip(slider, tooltipText)
		end

		return slider
	end

	-- Create checkbox
	local function CreateCheckBox(Label, Parent, dbValue, Point, ofsX, ofsY, tooltipText)
		local name = 'IB2:'.. Label
		local checkbox = CreateFrame('CheckButton', name, Parent, 'OptionsCheckButtonTemplate')
		_G[checkbox:GetName()..'Text']:SetText(Label)
		if ( dbValue ) then
			checkbox:SetChecked(true)
		else
			checkbox:SetChecked(false)
		end
		checkbox:SetPoint(Point, Parent, ofsX, ofsY)

		if ( tooltipText ) then
			AddTooltip(checkbox, tooltipText)
		end

		return checkbox
	end

	-- Create text string
	local function CreateText(Message, Parent, fontSize, Point, ofsX, ofsY)
		local text = Parent:CreateFontString(nil, 'ARTWORK')
		text:SetFont((GameFontHighlightSmallLeft:GetFont()), fontSize)
		text:SetText(Message)
		text:SetPoint(Point, Parent, ofsX, ofsY)

		return text
	end

	-- Create editbox
	local function CreateEditbox(Parent, frameName, tooltipText, Point, ofsX, ofsY)
		local frame = CreateFrame('EditBox', frameName, Parent, 'InputBoxTemplate')
		frame:SetSize(130, 55)
		frame:SetAutoFocus(false)
		frame:SetPoint(Point, ofsX, ofsY)

		if ( tooltipText ) then
			AddTooltip(frame, tooltipText)
		end

		return frame
	end

	local function FormatSpellName(getSpell)
		local getSpell = getSpell:gsub("(%a)(%a*)('*)(%a*)", function (a,b,c,d) return a:upper()..b:lower()..c..d:lower() end)
		local getSpell = getSpell:gsub('(The)', string.lower)
		local getSpell = getSpell:gsub('(Of)', string.lower)

		local totalInvalid = 0
		local blacklist = {
			['Interface\\Icons\\Trade_Alchemy'] = true,
			['Interface\\Icons\\Trade_BlackSmithing'] = true,
			['Interface\\Icons\\Trade_BrewPoison'] = true,
			['Interface\\Icons\\Trade_Engineering'] = true,
			['Interface\\Icons\\Trade_Engraving'] = true,
			['Interface\\Icons\\Trade_Fishing'] = true,
			['Interface\\Icons\\Trade_Herbalism'] = true,
			['Interface\\Icons\\Trade_LeatherWorking'] = true,
			['Interface\\Icons\\Trade_Mining'] = true,
			['Interface\\Icons\\Trade_Tailoring'] = true,
			['Interface\\Icons\\Temp'] = true,
		}
		for i = 1, 160000 do
			local name, rank, icon = GetSpellInfo(i)
			if ( name ) and not ( blacklist[icon] ) and ( rank ~= 'SPELL_PASSIVE' ) then
				if ( getSpell == name ) then
					return i
				end
			end
		end
	end

	----------------------
	-- Front Page
	----------------------

	IB2Options.refresh = function()
		if db.zoneBattle then IB2Options.CB2:SetChecked(true) else IB2Options.CB2:SetChecked(false) end
		if db.zoneArena then IB2Options.CB1:SetChecked(true) else IB2Options.CB1:SetChecked(false) end
		if db.barHideMode then IB2Options.CB3:SetChecked(true) else IB2Options.CB3:SetChecked(false) end
		if db.barSmartMode then IB2Options.CB5:SetChecked(true) else IB2Options.CB5:SetChecked(false) end
		if db.smartArena then IB2Options.CB4:SetChecked(true) else IB2Options.CB4:SetChecked(false) end
	end

	IB2Options.T1 = CreateText(L['InterruptBar2 Settings'], IB2Options, 20, 'TOP', -190, -20)
	IB2Options.T2 = CreateText(L['|cff32cd32Version 1.1.6'], IB2Options, 10, 'LEFT', 25, 230)

	IB2Options.T3 = CreateText(L['Enabled in area'], IB2Options, 12,'LEFT',30 , 190)

	IB2Options.CB1 = CreateCheckBox(L['Arena only'], IB2Options, db.zoneArena,'LEFT', 200, 160, L['Enable addon only when inside an arena.'])
	IB2Options.CB1:SetScript('OnClick', function()
		db.zoneArena = not db.zoneArena
		local _, instance = IsInInstance()
		IB:PLAYER_ENTERING_WORLD(instance)
	end)

	IB2Options.CB2 = CreateCheckBox(L['Battlegrounds'], IB2Options, db.zoneBattle, 'LEFT', 30, 160, L['Enable addon in battlegrounds.'])
	IB2Options.CB2:SetScript('OnClick', function()
		db.zoneBattle = not db.zoneBattle
		IB:Restart()
	end)

	IB2Options.T4 = CreateText(L['Setting modes'], IB2Options, 12, 'LEFT', 30, 90)

	IB2Options.CB3 = CreateCheckBox(L['Hide - mode'], IB2Options, db.barHideMode, 'LEFT', 30, 30, L['Show icons only when an ability is fired. Hides icon when cooldown is over.'])
	IB2Options.CB3:SetScript('OnClick', function()
		db.barHideMode = not db.barHideMode
		for _,btn in pairs(btns) do
			if btn.active then IB:Deactivate(btn) end
		end
		IB:UpdateFrame()
	end)

	IB2Options.CB4 = CreateCheckBox(L['Arena - mode'], IB2Options, db.smartArena,'LEFT', 190, 60, L['Shows an icon only if your arena opponent have the spell.'])
	IB2Options.CB4:SetScript('OnClick', function()
		db.smartArena = not db.smartArena
	end)

	IB2Options.CB5 = CreateCheckBox(L['Smart - mode'], IB2Options, db.barSmartMode, 'LEFT', 30, 60, L['Repositions the icons next to each other, to prevent blank spots on the bar. ( Needs Hide-Mode enabled to work! )'])
	IB2Options.CB5:SetScript('OnClick', function()
		db.barSmartMode = not db.barSmartMode
		IB:Restart()
	end)

	IB2Options.BTN1 = CreateButton(L['Test'], IB2Options, 'LEFT', 30, -255, L['Click to activate all spells.'])
	IB2Options.BTN1:SetSize(100, 25)
	IB2Options.BTN1:SetScript('OnClick', function()
		for _,btn in pairs(btns) do
			IB:Activate(btn, GetTime())
		end
	end)

	IB2Options.BTN2 = CreateButton(L['Unlock bar'], IB2Options, 'LEFT', 160 , -255, L['Click to lock/unlock the bar. Locking it prevents moving the bar, and also makes you able to click through it.'])
	IB2Options.BTN2:SetSize(100, 25)
	IB2Options.BTN2:SetScript('OnClick', function()
		db.barLock = not db.barLock
		IB:UpdateFrame()
	end)

	----------------------
	-- Icons
	----------------------

	local IB2OptionsIcon = CreateFrame('Frame')
	IB2OptionsIcon.name = L['Icons']
	IB2OptionsIcon.parent = IB2Options.name
	IB2OptionsIcon.refresh = function()
		IB2OptionsIcon.SL1:SetValue(db.growLeft)
		IB2OptionsIcon.SL2:SetValue(db.growUp)
		IB2OptionsIcon.SL3:SetValue(db.barScale)
		IB2OptionsIcon.SL4:SetValue(db.barCols)
		IB2OptionsIcon.SL5:SetValue(db.barTransparency)
		IB2OptionsIcon.SL6:SetValue(db.overlayDuration)
		if db.barTextures then IB2OptionsIcon.CB1:SetChecked(true) else IB2OptionsIcon.CB1:SetChecked(false) end
		if db.overlayFinish then IB2OptionsIcon.CB2:SetChecked(true) else IB2OptionsIcon.CB2:SetChecked(false) end
		if db.overlayStart then IB2OptionsIcon.CB3:SetChecked(true) else IB2OptionsIcon.CB3:SetChecked(false) end
	end

	IB2OptionsIcon.T1 = CreateText(L['Distance between icons'], IB2OptionsIcon, 12, 'TOP', -215, -20)

	IB2OptionsIcon.SL1 = CreateSlider(L['Offset X'], IB2OptionsIcon, 1, 10, 0.1, db.growLeft, 'LEFT', 30, 220, L['Change the spacing between icons. (Left/Right)'])
	IB2OptionsIcon.SL1:SetScript('OnValueChanged', function(self, value)
		_G[self:GetName() .. 'Text']:SetText(L['Offset X'] .. ' (' .. IB:FormatValue(value) .. ')')
		db.growLeft = IB:FormatValue(value)
		IB:Restart()
	end)

	IB2OptionsIcon.SL2 = CreateSlider(L['Offset Y'], IB2OptionsIcon.SL1, 1, 10, 0.1, db.growUp, 'LEFT', 225, 0, L['Change the spacing between icons. (Down/Up)'])
	IB2OptionsIcon.SL2:SetScript('OnValueChanged', function(self, value)
		if ( db.barCols < 0 ) then
			return
		else
			_G[self:GetName() .. 'Text']:SetText(L['Offset Y'] .. ' (' .. IB:FormatValue(value) .. ')')
			db.growUp = IB:FormatValue(value)
			IB:Restart()
		end
	end)

	IB2OptionsIcon.T2 = CreateText(L['Icon size and columns'], IB2OptionsIcon, 12, 'TOP', -215, -115)

	IB2OptionsIcon.SL3 = CreateSlider(L['Icon Scale'], IB2OptionsIcon, 0.1, 5, 0.1, db.barScale, 'LEFT', 30, 125, L['Change the scale of the whole bar. Timer/icons will scale accordingly.'])
	IB2OptionsIcon.SL3:SetScript('OnValueChanged', function(self, value)
		_G[self:GetName() .. 'Text']:SetText(L['Icon Scale'] .. ' (' .. IB:FormatValue(value) .. ')')
		db.barScale = IB:FormatValue(value)
		IB:UpdateFrame()
	end)

	IB2OptionsIcon.SL4 = CreateSlider(L['Bar Coloumns'], IB2OptionsIcon.SL3, 0, 25, 1, db.barCols, 'LEFT', 225, 0, L['Change how many abilities to have per row.'])
	IB2OptionsIcon.SL4:SetScript('OnValueChanged', function(self, value)
		_G[self:GetName() .. 'Text']:SetText(L['Bar Coloumns'] .. ' (' .. IB:FormatValue(value) .. ')')
		db.barCols = IB:FormatValue(value)
		IB:Restart()
	end)

	IB2OptionsIcon.T3 = CreateText(L['Transparency settings'], IB2OptionsIcon, 12, 'LEFT', 25, 70)

	IB2OptionsIcon.SL5 = CreateSlider(L['Icon Transparency'], IB2OptionsIcon, 0.2, 1, 0.1, db.barTransparency, 'LEFT', 30, 30, L['Apply transparency to an icon when a cooldown is over. Set to 1 to disable. See timer options to change transparency when a cooldown started.'])
	IB2OptionsIcon.SL5:SetScript('OnValueChanged', function(self, value)
		_G[self:GetName() .. 'Text']:SetText(L['Icon Transparency'] .. ' (' .. IB:FormatValue(value) .. ')')
		db.barTransparency = IB:FormatValue(value)
		IB:UpdateFrame()
	end)

	IB2OptionsIcon.T4 = CreateText(L['Border textures'], IB2OptionsIcon, 12, 'LEFT', 25, -30)

	IB2OptionsIcon.CB1 = CreateCheckBox(L['Show borders'], IB2OptionsIcon, db.barTextures, 'LEFT', 40, -65, L['Show border on icons.'])
	IB2OptionsIcon.CB1:SetScript('OnClick', function()
		db.barTextures = not db.barTextures
		IB:Restart()
	end)


	IB2OptionsIcon.T5 = CreateText(L['Activation Flash'], IB2OptionsIcon, 12, 'LEFT', 25, -133)

	IB2OptionsIcon.SL6 = CreateSlider(L['Duration'], IB2OptionsIcon, 0, 4, .1, db.overlayDuration, 'LEFT', 30, -170, L['How long until the activation flash fades away.'])
	IB2OptionsIcon.SL6:SetScript('OnValueChanged', function(self, value)
		_G[self:GetName() .. 'Text']:SetText(L['Duration'] .. ' (' .. IB:FormatValue(value) .. ')')
		db.overlayDuration = IB:FormatValue(value)
	end)

	IB2OptionsIcon.CB2 = CreateCheckBox(L['Show on spell finished'], IB2OptionsIcon, db.overlayFinish, 'LEFT', 30,-220, L['Show activation flash when a cooldown is over.'])
	IB2OptionsIcon.CB2:SetScript('OnClick', function()
		db.overlayFinish = not db.overlayFinish
	end)

	IB2OptionsIcon.CB3 = CreateCheckBox(L['Show on spell used'], IB2OptionsIcon, db.overlayStart, 'LEFT', 30,-250, L['Show activation flash when an ability is fired.'])
	IB2OptionsIcon.CB3:SetScript('OnClick', function()
		db.overlayStart = not db.overlayStart
	end)

	IB2OptionsIcon.BTN1 = CreateButton(L['Test'], IB2OptionsIcon, 'LEFT', 480, -255, L['Click to activate all spells.'])
	IB2OptionsIcon.BTN1:SetSize(100, 25)
	IB2OptionsIcon.BTN1:SetScript('OnClick', function()
		for _,btn in pairs(btns) do
			IB:Activate(btn, GetTime())
		end
	end)

	----------------------
	-- Add new spell
	----------------------

	local IB2OptionsSpell = CreateFrame('Frame')
	IB2OptionsSpell.name = L['Spell List']
	IB2OptionsSpell.parent = IB2Options.name

	local ix, yx = 30, 60
	local function generateIcons()
		local tablee = db.abilities
		for class,ntable in pairs(tablee) do
			for spell,cd in pairs(ntable) do
				local frame = CreateFrame("Frame",nil,IB2OptionsSpell)
				frame:EnableMouse(true)
				local _,_,icon = GetSpellInfo(spell)
				frame.tex = frame:CreateTexture(nil,'OVERLAY')
				frame.tex:SetTexture(icon)
				frame.tex:SetSize(30,30)
				frame:SetSize(30,30)
				frame.tex:SetAllPoints(frame)
				frame:SetScript('OnMouseDown', function(self,button)
					if ( button == 'LeftButton') then
						db.abilities[class][spell] = nil
						frame:SetAlpha(0.4)
						IB:Restart()
					elseif ( button == 'RightButton' ) then
						db.abilities[class][spell] = cd
						frame:SetAlpha(1)
						IB:Restart()
					end
				end)
				frame:SetPoint('LEFT', IB2OptionsSpell, 'LEFT', ix, yx)
				frame:Show()

				yx = yx - 30
				if yx < -260 then
					ix = ix + 30
					yx = 60
				end
			end
		end
	end

	IB2OptionsSpell.T1 = CreateText(L['Add / Delete spells'], IB2OptionsSpell, 16,'LEFT', 25, 260)

	IB2OptionsSpell.DD1 = dropdownLib:New(IB2OptionsSpell, L['Select class'], L['Select the class of who the spell is used by.'],{{text = L['Warrior'],value = 'WARRIOR',disabled = false,empty = false,},{text = L['Warlock'],value = 'WARLOCK',disabled = false,empty = false,},{text = L['Shaman'],value = 'SHAMAN',disabled = false,empty = false,},{text = L['Rogue'],value = 'ROGUE',disabled = false,empty = false,},{text = L['Priest'],value = 'PRIEST',disabled = false,empty = false,},{text = L['Paladin'],value = 'PALADIN',disabled = false,empty = false,},{text = L['Monk'],value = 'MONK',disabled = false,empty = false,},{text = L['Hunter'],value = 'HUNTER',disabled = false,empty = false,},{text = L['Druid'],value = 'DRUID',disabled = false,empty = false,},{text = L['Death Knight'],value = 'DEATHKNIGHT',disabled = false,empty = false,},{text = L['Mage'],value = 'MAGE',disabled = false,empty = false,}},true)
	IB2OptionsSpell.DD1:SetPoint('LEFT', 320, 195)

	IB2OptionsSpell.T2 = CreateText(L['Spell'], IB2OptionsSpell, 12,'LEFT', 25, 210)
	IB2OptionsSpell.T2:SetTextColor(0.9,0.8,0,1)

	IB2OptionsSpell.EB1 = CreateEditbox(IB2OptionsSpell, 'IB:EB1S', L["The spell's name or ID that you want to add. See documentation on Curse for help."], 'LEFT', 30, 187)
	
	IB2OptionsSpell.T4 = CreateText(L['Cooldown'], IB2OptionsSpell, 12,'LEFT', 190, 210)
	IB2OptionsSpell.T4:SetTextColor(0.9,0.8,0,1)
	IB2OptionsSpell.EB2 = CreateEditbox(IB2OptionsSpell, 'IB:EB2S', L["The spell's cooldown that you want to add. Only necessary if you want to add spells that have a reduced cooldown, by for example PvP setbonuses or glyphs. Leaving it blank will auto-retrieve the original cooldown of the spell."], 'LEFT', 195, 187)
	IB2OptionsSpell.EB2:SetWidth(60)
	IB2OptionsSpell.T6 = CreateText(L['sec'], IB2OptionsSpell, 9,'LEFT', 260, 187)

	IB2OptionsSpell.BTN1 = CreateButton(L['Add'], IB2OptionsSpell, 'LEFT', 25, 150)
	IB2OptionsSpell.BTN1:SetSize(135,25)
	IB2OptionsSpell.BTN1:SetScript('OnClick', function()
		local getSpell = IB2OptionsSpell.EB1:GetText()
		local getclassName = IB2OptionsSpell.DD1:GetValue()
		local getCooldown = IB2OptionsSpell.EB2:GetText()
			
		if ( getSpell ) and ( getclassName ) then
			local spellCD
			local spellName
			
			if ( tonumber(getSpell) ) then
				-- Input is not string
				spellName = tonumber(getSpell)
				if ( getCooldown ) and tonumber(getCooldown) then
					spellCD = tonumber(getCooldown)
				else
					if chargedSpells[spellName] then
						for k,v in pairs(chargedSpells) do
							if k == spellName then
								spellCD = v
								break
							end
						end
					else
						spellCD = GetSpellBaseCooldown(spellName)
						if ( spellCD ) then
							spellCD = spellCD / 1000
						else
							Log(L['Could not retrieve cooldown for spell: ']..spellName)
							return
						end
					end
				end
			else -- Input is string
				spellName = FormatSpellName(getSpell) -- Convert spell name to spell id
				if ( spellName ) then
					if ( spellName == 2066 ) then
						spellName = 22812
					end
					
					if ( getCooldown ) and tonumber(getCooldown) then
						spellCD = tonumber(getCooldown)
					else
						spellCD = GetSpellBaseCooldown(spellName)
						if ( spellCD ) then
							spellCD = spellCD / 1000
						else
							-- Invalid spell ID sent to GetSpellBaseCooldown
							Log(L['Could not retrieve cooldown for spell: ']..spellName)
							return
						end
					end
				else
					-- Couldn't convert spell name to spell id
					Log(L['Invalid input or spell.'])
					return
				end
			end

			if ( spellName ) and ( spellCD ) and ( getclassName ) then
				if not ( db.abilities[getclassName][spellName] ) then
					if ( spellCD < 2 ) then
						Log(L['Too short cooldown for spell: ']..spellName)
						return
					end


				db.abilities[getclassName][spellName] = spellCD

				local _,_,icon = GetSpellInfo(spellName)
				local frame = CreateFrame("Frame",nil,IB2OptionsSpell)
					frame:EnableMouse(true)
					frame.tex = frame:CreateTexture(nil,'OVERLAY')
					frame.tex:SetTexture(icon)
					frame.tex:SetSize(30,30)
					frame:SetSize(30,30)
					frame.tex:SetAllPoints(frame)
					frame:SetScript('OnMouseDown', function(self,button)
						if ( button == 'LeftButton') then
							db.abilities[getclassName][spellName] = nil
							frame:SetAlpha(0.4)
							IB:Restart()
						elseif ( button == 'RightButton' ) then
							db.abilities[getclassName][spellName] = spellCD
							frame:SetAlpha(1)
							IB:Restart()
						end
					end)
					frame:SetPoint('LEFT', IB2OptionsSpell, 'LEFT', ix, yx)
					frame:Show()
					yx = yx - 30
					if yx < -260 then
						ix = ix + 30
						yx = 60
					end

					IB:Restart()
					IB2OptionsSpell.EB1:SetText('')
					IB2OptionsSpell.EB2:SetText('')

					Log(spellName..L[' successfully added with cooldown: ']..spellCD)
				else
					Log(spellName..L[' already exists.'])
				end
			end
		end
	end)

	IB2OptionsSpell.T3 = CreateText(L['Left-click on a spell icon to |cFFFF0000DELETE|r it from the bar. Right-Click to re-add it.'], IB2OptionsSpell, 12,'LEFT', 25, 90)
	IB2OptionsSpell.T3:SetTextColor(0.9,0.8,0,1)

	generateIcons()

	----------------------
	-- Timer
	----------------------
	local IB2OptionsTimer = CreateFrame('Frame')
	IB2OptionsTimer.name = L['Timer']
	IB2OptionsTimer.parent = IB2Options.name
	IB2OptionsTimer.refresh = function()
		IB2OptionsTimer.SL1:SetValue(db.timerOffsetX)
		IB2OptionsTimer.SL2:SetValue(db.timerOffsetY)
		IB2OptionsTimer.SL3:SetValue(db.timerScaleFiveLeft)
		IB2OptionsTimer.SL4:SetValue(db.barTransparencyFiveLeft)
		IB2OptionsTimer.SL5:SetValue(db.timerScale)
		IB2OptionsTimer.SL6:SetValue(db.barTransparencySeconds)
		IB2OptionsTimer.SL7:SetValue(db.timerScaleMinute)
		IB2OptionsTimer.SL8:SetValue(db.barTransparencyMinute)

		if db.timerDecimal then IB2OptionsTimer.CB1:SetChecked(true) else IB2OptionsTimer.CB1:SetChecked(false) end
		if db.timerHide then IB2OptionsTimer.CB2:SetChecked(true) else IB2OptionsTimer.CB2:SetChecked(false) end
		if db.spiralHide then IB2OptionsTimer.CB3:SetChecked(true) else IB2OptionsTimer.CB3:SetChecked(false) end
	end


	IB2OptionsTimer.BTN1 = CreateButton(L['Test'], IB2OptionsTimer, 'LEFT', 30, -255, L['Click to activate all spells.'])
	IB2OptionsTimer.BTN1:SetSize(100, 25)
	IB2OptionsTimer.BTN1:SetScript('OnClick', function()
		for _,btn in pairs(btns) do
			IB:Activate(btn, GetTime())
		end
	end)


	IB2OptionsTimer.T1 = CreateText(L['Text Position'], IB2OptionsTimer, 12, 'LEFT', 25, 240)

	-- Text Offset X
	IB2OptionsTimer.SL1 = CreateSlider(L['Text Offset X'], IB2OptionsTimer, -300, 300, 1, db.timerOffsetX, 'LEFT', 30, 200, L['Change the position of the timer text. (Left/Right)'])
	IB2OptionsTimer.SL1:SetScript('OnValueChanged', function(self, value)
		_G[self:GetName() .. 'Text']:SetText(L['Text Offset X'] .. ' (' .. IB:FormatValue(value) .. ')')
		db.timerOffsetX = IB:FormatValue(value)
		IB:Restart()
	end)

	-- Text Offset Y
	IB2OptionsTimer.SL2 = CreateSlider(L['Text Offset Y'], IB2OptionsTimer.SL1, -300, 300, 1, db.timerOffsetY, 'LEFT', 175,0, L['Change the position of the timer text. (Down/Up)'])
	IB2OptionsTimer.SL2:SetScript('OnValueChanged', function(self, value)
		_G[self:GetName() .. 'Text']:SetText(L['Text Offset Y'] .. ' (' .. IB:FormatValue(value) .. ')')
		db.timerOffsetY = IB:FormatValue(value)
		IB:Restart()
	end)

	IB2OptionsTimer.BTN2 = CreateButton(L['Reset'], IB2OptionsTimer, 'LEFT', 370, 200, L['Reset text position to default.'])
	IB2OptionsTimer.BTN2:SetSize(45, 20)
	IB2OptionsTimer.BTN2:SetScript('OnClick', function()
		db.timerOffsetX = 0
		db.timerOffsetY = 0
		IB2OptionsTimer.SL2:SetValue(db.timerOffsetY)
		IB2OptionsTimer.SL1:SetValue(db.timerOffsetX)
		IB:Restart()
	end)


	IB2OptionsTimer.T2 = CreateText(L['Misc Timer Settings'], IB2OptionsTimer, 12, 'LEFT', 25, 115)

	-- Hide decimals
	IB2OptionsTimer.CB1 = CreateCheckBox(L['Do not show decimals'], IB2OptionsTimer, db.timerDecimal, 'left', 30, 80, L['Do not show decimals in countdown numbers. E.g: 1 instead of 1.0'])
	IB2OptionsTimer.CB1:SetScript('OnClick', function()
		db.timerDecimal = not db.timerDecimal
	end)

	-- Hide text
	IB2OptionsTimer.CB2 = CreateCheckBox(L['Disable timer'], IB2OptionsTimer.CB1, db.timerHide, 'LEFT', 230, 0, L['Disable the timer number countdown module.'])
	IB2OptionsTimer.CB2:SetScript('OnClick', function()
		db.timerHide = not db.timerHide
		for _,btn in pairs(btns) do
			btn:Hide()
			btn:SetParent(nil)
		end
		wipe(btns)
		IB:CreateBar()
	end)

	-- Cooldown Spiral
	IB2OptionsTimer.CB3 = CreateCheckBox(L['Disable Blizzard cooldown spiral'], IB2OptionsTimer, db.spiralHide, 'LEFT', 30, 40, L['Disable the transparent swipe cooldown effect.'])
	IB2OptionsTimer.CB3:SetScript('OnClick', function()
		db.spiralHide = not db.spiralHide
		IB:Restart()
	end)

	-- Soon timer color
	IB2OptionsTimer.CP1 = colorLib:New(IB2OptionsTimer, L['Timer Soon Color'], L['Color of the timer when cooldown is less than 5 seconds.'], true)
	IB2OptionsTimer.CP1:SetValue(db.timerColorFiveLeft)
	IB2OptionsTimer.CP1:SetPoint('LEFT', 30, -60)
	function IB2OptionsTimer.CP1:Callback(r, g, b, a)
		db.timerColorFiveLeft['r'] = r
		db.timerColorFiveLeft['g'] = g
		db.timerColorFiveLeft['b'] = b
		db.timerColorFiveLeft['a'] = a
	end

	-- Soon timer size
	IB2OptionsTimer.SL3 = CreateSlider(L['Timer Soon Size'], IB2OptionsTimer.CP1, 7, 35, 1, db.timerScaleFiveLeft, 'LEFT', 220, 0, L['Font size of the timer text when cooldown is less than 5 seconds.'])
	IB2OptionsTimer.SL3:SetWidth(100)
	IB2OptionsTimer.SL3:SetScript('OnValueChanged', function(self, value)
		_G[self:GetName() .. 'Text']:SetText(L['Timer Soon Size'] .. ' (' .. IB:FormatValue(value) .. ')')
		db.timerScaleFiveLeft = IB:FormatValue(value)
		IB:Restart()
	end)

	-- Soon icon opacity
	IB2OptionsTimer.SL4 = CreateSlider(L['Icon Soon Opacity'], IB2OptionsTimer.SL3, .2, 1, .1, db.barTransparencyFiveLeft,'LEFT', 170, 0, L['Transparent value of the ability icon when cooldown is less than 5 seconds.'])
	IB2OptionsTimer.SL4:SetWidth(100)
	IB2OptionsTimer.SL4:SetScript('OnValueChanged', function(self, value)
		_G[self:GetName() .. 'Text']:SetText(L['Icon Soon Opacity'] .. ' (' .. IB:FormatValue(value) .. ')')
		db.barTransparencyFiveLeft = IB:FormatValue(value)
	end)


	-- Default timer color
	IB2OptionsTimer.CP2 = colorLib:New(IB2OptionsTimer, L['Timer Seconds Color'], L['Color of the timer when cooldown is less than 60 seconds.'], true)
	IB2OptionsTimer.CP2:SetValue(db.timerColor)
	IB2OptionsTimer.CP2:SetPoint('LEFT', 30, -120)
	function IB2OptionsTimer.CP2:Callback(r, g, b, a)
		db.timerColor['r'] = r
		db.timerColor['g'] = g
		db.timerColor['b'] = b
		db.timerColor['a'] = a
	end

	-- Default timer size
	IB2OptionsTimer.SL5 = CreateSlider(L['Timer Seconds Size'], IB2OptionsTimer.CP2, 7, 35, 1, db.timerScale, 'LEFT', 220, 0, L['Font size of the timer text when cooldown is less than 60 seconds.'])
	IB2OptionsTimer.SL5:SetWidth(100)
	IB2OptionsTimer.SL5:SetScript('OnValueChanged', function(self, value)
		_G[self:GetName() .. 'Text']:SetText(L['Timer Seconds Size'] .. ' (' .. IB:FormatValue(value) .. ')')
		db.timerScale = IB:FormatValue(value)
		IB:Restart()
	end)

	-- Default icon opacity
	IB2OptionsTimer.SL6 = CreateSlider(L['Icon Seconds Opacity'], IB2OptionsTimer.SL5, .2, 1, .1, db.barTransparencySeconds, 'LEFT', 170, 0, L['Transparent value of the ability icon when cooldown is less than 60 seconds.'])
	IB2OptionsTimer.SL6:SetWidth(100)
	IB2OptionsTimer.SL6:SetScript('OnValueChanged', function(self, value)
		_G[self:GetName() .. 'Text']:SetText(L['Icon Seconds Opacity'] .. ' (' .. IB:FormatValue(value) .. ')')
		db.barTransparencySeconds = IB:FormatValue(value)
	end)


	-- Minute timer color
	IB2OptionsTimer.CP3 = colorLib:New(IB2OptionsTimer, L['Timer Minute Color'], L['Color of the timer when cooldown is greater than 60 seconds.'], true)
	IB2OptionsTimer.CP3:SetValue(db.timerColorMinute)
	IB2OptionsTimer.CP3:SetPoint('LEFT', 30, -180)
	function IB2OptionsTimer.CP3:Callback(r, g, b, a)
		db.timerColorMinute['r'] = r
		db.timerColorMinute['g'] = g
		db.timerColorMinute['b'] = b
		db.timerColorMinute['a'] = a
	end

	-- Minute timer size
	IB2OptionsTimer.SL7 = CreateSlider(L['Timer Minute Size'], IB2OptionsTimer.CP3, 7, 35, 1, db.timerScaleMinute,'LEFT', 220, 0, L['Font size of the timer text when cooldown is greater than 60 seconds.'])
	IB2OptionsTimer.SL7:SetWidth(100)
	IB2OptionsTimer.SL7:SetScript('OnValueChanged', function(self, value)
		_G[self:GetName() .. 'Text']:SetText(L['Timer Minute Size'] .. ' (' .. IB:FormatValue(value) .. ')')
		db.timerScaleMinute = IB:FormatValue(value)
		IB:Restart()
	end)

	-- Minute icon opacity
	IB2OptionsTimer.SL8 = CreateSlider(L['Icon Minute Opacity'], IB2OptionsTimer.SL7, .2, 1, .1, db.barTransparencyMinute, 'LEFT', 170, 0, L['Transparent value of the ability icon when cooldown is greater than 60 seconds.'])
	IB2OptionsTimer.SL8:SetWidth(100)
	IB2OptionsTimer.SL8:SetScript('OnValueChanged', function(self, value)
		_G[self:GetName() .. 'Text']:SetText(L['Icon Minute Opacity'] .. ' (' .. IB:FormatValue(value) .. ')')
		db.barTransparencyMinute = IB:FormatValue(value)
	end)

	-- << ANNOUNCEMENTS  & COMBAT >>
	local IB2OptionsAnnounce = CreateFrame('Frame')
	IB2OptionsAnnounce.name = L['Announcements']
	IB2OptionsAnnounce.parent = IB2Options.name
	IB2OptionsAnnounce.refresh = function()
		if db.announceOnUse then IB2OptionsAnnounce.CB1:SetChecked(true) else IB2OptionsAnnounce.CB1:SetChecked(false) end
		if db.announceFinish then IB2OptionsAnnounce.CB2:SetChecked(true) else IB2OptionsAnnounce.CB2:SetChecked(false) end
		if db.announceFiveLeft then IB2OptionsAnnounce.CB3:SetChecked(true) else IB2OptionsAnnounce.CB3:SetChecked(false) end
	end

	IB2OptionsAnnounce.T1 = CreateText(L['When to announce'], IB2OptionsAnnounce, 12,'LEFT', 30, 260)

	IB2OptionsAnnounce.CB1 = CreateCheckBox(L['Ability used'], IB2OptionsAnnounce, db.announceOnUse,'LEFT',40,230, L['Announce when an ability is fired.'])
	IB2OptionsAnnounce.CB1:SetScript('OnClick', function()
		db.announceOnUse = not db.announceOnUse
	end)

	IB2OptionsAnnounce.CB2 = CreateCheckBox(L['Cooldown finished'], IB2OptionsAnnounce, db.announceFinish,'LEFT',40, 205, L['Announce when an ability cooldown is over.'])
	IB2OptionsAnnounce.CB2:SetScript('OnClick', function()
		db.announceFinish = not db.announceFinish
	end)

	IB2OptionsAnnounce.CB3 = CreateCheckBox(L['Cooldown less than 5sec'], IB2OptionsAnnounce, db.announceFiveLeft,'LEFT',40, 180, L['Announce when an ability cooldown duration is less than 5 seconds.'])
	IB2OptionsAnnounce.CB3:SetScript('OnClick', function()
		db.announceFiveLeft = not db.announceFiveLeft
	end)

	IB2OptionsAnnounce.DD1 = dropdownLib:New(IB2OptionsAnnounce, L['Select channel'], L["Select which channel you want to send the announcement message to."], {{text = L['Say'],value = 'SAY',disabled = false,empty = false,},{text = L['Yell'],value = 'YELL',disabled = false,empty = false,},{text = L['Party'],value = 'PARTY',disabled = false,empty = false,},{text = L['Raid'],value = 'RAID',disabled = false,empty = false,},}, true)
	IB2OptionsAnnounce.DD1:SetPoint('LEFT', 40, 120)
	function IB2OptionsAnnounce.DD1:Callback(dropdown, value)
		db.announceChannel = value
	end
	IB2OptionsAnnounce.DD1:SetValue(db.announceChannel)

	----------------------
	-- Fonts
	----------------------
	--[[local IB2OptionsFont = CreateFrame('Frame')
	IB2OptionsFont.name = L['Font']
	IB2OptionsFont.parent = IB2Options.name

	IB2OptionsFont.T1 = CreateText(L['Font properties for the timer countdown text:'], IB2OptionsFont, 12,'LEFT', 30, 240)

	IB2OptionsFont.DD1 = dropdownLib:New(IB2OptionsFont, L['Font Outline'], L["Select which font outline to use."],
	{ 
		{text = 'Monochrome',value = 'MONOCHROME',disabled = false,empty = false,},
		{text = 'Outline',value = 'OUTLINE',disabled = false,empty = false,},
		{text = 'Thick outline',value = 'THICKOUTLINE',disabled = false,empty = false,},
	}, true)
	IB2OptionsFont.DD1:SetPoint('LEFT', 40, 180)
	function IB2OptionsFont.DD1:Callback(dropdown, value)
		db.fontOutline = value
		IB:Restart()
	end
	IB2OptionsFont.DD1:SetValue(db.fontOutline)

	IB2OptionsFont.DD2 = dropdownLib:New(IB2OptionsFont, L['Font Type'], L["Select which font type to use."], {
		{text = 'Friz Quadrata',value = 'Fonts\\FRIZQT__.TTF',disabled = false,empty = false,},
		{text = 'Arial Narrow',value = 'Fonts\\ARIALN.TTF',disabled = false,empty = false,},
		{text = 'Skurri',value = 'Fonts\\skurri.TTF',disabled = false,empty = false,},
		{text = 'Morpheus',value = 'Fonts\\MORPHEUS.TTF',disabled = false,empty = false,},
	}, true)
	IB2OptionsFont.DD2:SetPoint('LEFT', 300, 180)
	function IB2OptionsAnnounce.DD1:Callback(dropdown, value)
		db.fontType = value
		IB:Restart()
	end
	IB2OptionsFont.DD2:SetValue(db.fontType)]]

	----------------------
	-- Profiles
	----------------------
	local IB2OptionsProfiles = CreateFrame('Frame')
	IB2OptionsProfiles.name = L['Profiles']
	IB2OptionsProfiles.parent = IB2Options.name

	IB2OptionsProfiles.T3 = CreateText(L['Reset your current active profile'], IB2OptionsProfiles, 10,'LEFT', 30, 40)
	
	IB2OptionsProfiles.BTN1 = CreateButton(L['Reset current profile'], IB2OptionsProfiles, 'LEFT', 30, 10, L['Reset your current profile back to its default values.'])
	IB2OptionsProfiles.BTN1:SetSize(150, 25)
	IB2OptionsProfiles.BTN1:SetScript('OnClick', function()
		IB2Options.default()
		Log(L['Profile reseted to default settings.'])
		Log(L['A /reload may be necessary to see the changes in the options panel.'])
	end)

	local itemListCopy, itemListDelete = {}, {}
	local function dropdownProfileList()
		for k,v in pairs(InterruptBar2DB) do
			if k then
			table.insert(itemListCopy,
						{
						text = k,
						value = v,
						disabled = false,
						empty = false,
					}
				)
			--
			table.insert(itemListDelete,
						{
						text = k,
						value = k,
						disabled = false,
						empty = false,
					}
				)
			end
		end
	end
	dropdownProfileList()

	IB2OptionsProfiles.T1 = CreateText(L['Copy the settings from one existing profile into the currently active profile.'], IB2OptionsProfiles, 10,'LEFT', 30, 250)

	IB2OptionsProfiles.DD1 = dropdownLib:New(IB2OptionsProfiles, L['Copy a profile'], L["Select the profile you want to copy. The selected profile will overwrite your current settings."], {}, true)
	IB2OptionsProfiles.DD1:SetPoint('LEFT', 30, 200)
	IB2OptionsProfiles.DD1:SetList(itemListCopy)

	IB2OptionsProfiles.BTN2 = CreateButton(L['Copy'], IB2OptionsProfiles.DD1, 'LEFT', 190, -6)
	IB2OptionsProfiles.BTN2:SetSize(45, 20)
	IB2OptionsProfiles.BTN2:SetScript('OnClick', function()
		local settings = IB2OptionsProfiles.DD1:GetValue()
		if not settings then return end
		IB:Disable()
		InterruptBar2DB[playerName] = settings
		IB:SavedVariables()
		IB:CreateBar()
		IB:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
		IB:RegisterEvent('ARENA_PREP_OPPONENT_SPECIALIZATIONS')
		Log(L['Copied profile.'])
		Log(L['A /reload may be necessary to see the changes in the options panel.'])
	end)

	IB2OptionsProfiles.T2 = CreateText(L['Delete existing profiles from the database.'], IB2OptionsProfiles, 10,'LEFT', 30, 140)
	IB2OptionsProfiles.DD2 = dropdownLib:New(IB2OptionsProfiles, L['Delete a profile'], L["Select the profile you want to permanetly delete."], {}, true)
	IB2OptionsProfiles.DD2:SetPoint('LEFT', 30, 90)
	IB2OptionsProfiles.DD2:SetList(itemListDelete)

	IB2OptionsProfiles.BTN3 = CreateButton(L['Delete'], IB2OptionsProfiles.DD2, 'LEFT', 190, -6)
	IB2OptionsProfiles.BTN3:SetSize(50, 22)
	IB2OptionsProfiles.BTN3:SetScript('OnClick', function()
		local profileName = IB2OptionsProfiles.DD2:GetValue()
		InterruptBar2DB[profileName] = nil
		Log(L['Deleted profile: '].. profileName)
		Log(L['A /reload may be necessary to see the changes in the options panel.'])
		wipe(itemListDelete)
		wipe(itemListCopy)
		dropdownProfileList()
		IB2OptionsProfiles.DD1:SetList(itemListCopy)
		IB2OptionsProfiles.DD2:SetList(itemListDelete)
	end)


	-------------
	for _,name in ipairs({IB2OptionsIcon,IB2OptionsTimer,IB2OptionsAnnounce,IB2OptionsSpell,IB2OptionsProfiles}) do
		InterfaceOptions_AddCategory(name)
	end
end

----------------------------------
-- Options End
----------------------------------





----------------------------------
-- Startup / Events
----------------------------------

-- Initialize everything
function IB:PLAYER_LOGIN()
	IB:SavedVariables()
	IB:RegisterEvent('PLAYER_ENTERING_WORLD')
	IB:CreateBar()

	IB2Options = CreateFrame('Frame')
	IB2Options.name = L['InterruptBar2']
	IB2Options.default = function()
		IB:Disable()
		wipe(db)
		wipe(InterruptBar2DB)
		IB:SavedVariables()
		IB:CreateBar()
		IB:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
		IB:RegisterEvent('ARENA_PREP_OPPONENT_SPECIALIZATIONS')
		IB:RegisterEvent('ARENA_OPPONENT_UPDATE')
	end

	IB2Options.BTN0 = CreateButton(L['Load Options'], IB2Options, 'LEFT', 40, 250)
	IB2Options.BTN0:SetWidth(175)
	IB2Options.BTN0:SetScript('OnClick', function()
		IB:LoadOptions()
		IB.LoadOptions = nil
		IB2Options.BTN0:Hide()
		InterfaceAddOnsList_Update()
		InterfaceOptionsFrame_OpenToCategory(L['Icons'])
		InterfaceOptionsFrame_OpenToCategory(L['InterruptBar2'])
	end)
	InterfaceOptions_AddCategory(IB2Options)

	SLASH_InterruptBar1 = '/ib'
	SlashCmdList['InterruptBar'] = function()
		InterfaceOptionsFrame_OpenToCategory(L['InterruptBar2'])
		InterfaceOptionsFrameOkay:Click('button', down)
		InterfaceOptionsFrame_OpenToCategory(L['InterruptBar2'])
	end
end

-- Check if in world/bg/arena
function IB:ZoneCheck(instance)
	local zoneType

	if ( instance == 'pvp' ) then
		zoneType = 1 -- BattleGround
	elseif ( instance == 'arena' ) then
		zoneType = 2 -- Arena
	end
	if ( zoneType == nil ) then
		zoneType = 0 -- World
	end
	return zoneType
end

--
function IB:Disable()
	IB:UnregisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
	IB:UnregisterEvent('ARENA_PREP_OPPONENT_SPECIALIZATIONS')
	IB:UnregisterEvent('ARENA_OPPONENT_UPDATE')
	for _,btn in pairs(btns) do
		if ( btn.active ) then
			IB:Deactivate(btn)
		end
		btn:Hide()
		btn = nil
	end
	wipe(btns)
	wipe(unitCache)
	bar:Hide()
	IB:RegisterEvent('PLAYER_ENTERING_WORLD')
end

--
function IB:PLAYER_ENTERING_WORLD(instance)
	local zoneType = IB:ZoneCheck(instance)

	if ( zoneType == 1 ) and not ( db.zoneBattle ) or ( db.zoneArena ) and ( zoneType ~= 2 ) then
		IB:Disable()
	else
		-- Run
		IB:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
		if ( zoneType == 2 ) and ( db.smartArena ) then
			IsInArena = true
			IB:Disable()
			IB:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
			IB:RegisterEvent('ARENA_PREP_OPPONENT_SPECIALIZATIONS')
			IB:RegisterEvent('ARENA_OPPONENT_UPDATE')
			offsetX = 15+((db.barCols/2)*-36*((db.growLeft+1)/2))+((db.barCols/2)*-36*((db.growLeft-1)/2))
			count   = 0
		offsetY = 0
		else
			IsInArena = false
			IB:Restart()
		end
	end
end

-- Event Handler
IB:RegisterEvent('PLAYER_LOGIN')
IB:SetScript('OnEvent', function(self, event, ...)
	if ( event == 'COMBAT_LOG_EVENT_UNFILTERED' ) then
		IB:CLEU(...)
		return
	elseif ( event == 'PLAYER_LOGIN' ) then
		IB:PLAYER_LOGIN()
		IB:UnregisterEvent('PLAYER_LOGIN')
		return
	elseif ( event == 'PLAYER_ENTERING_WORLD' ) then
		local _,instance = IsInInstance()
		IB:PLAYER_ENTERING_WORLD(instance)
		return
	elseif ( event == 'ARENA_PREP_OPPONENT_SPECIALIZATIONS' ) or ( event == 'ARENA_OPPONENT_UPDATE' ) then
		IB:DetectArena(event, ...)
	end
end)
